<?php
/* Autor...:  */
/* Esquema.: MST_ReferenciaProductoCatTalla.xml */
/* Generado: 2024-08-20 23:01:57 */

/* Metodos de acceso a los campos de la tabla MST_ReferenciaProductoCatTalla */
abstract class BaseMST_ReferenciaProductoCatTallaBN
{
    /* Campos de la tabla */
    private $i_IdReferencia;    // IdReferencia: ( no definido )
    private $i_IdColor;    // IdColor: ( no definido )
    private $i_IdCatTalla;    // IdCatTalla: ( no definido )
    private $i_Aplicado;    // Aplicado: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )

    /* Establece el valor del campo IdReferencia */
    public function setIdReferencia( $i_IdReferencia )
    {
        $this->i_IdReferencia = $i_IdReferencia;
    }

    /* Obtiene el valor del campo IdReferencia */
    public function getIdReferencia()
    {
        return $this->i_IdReferencia;
    }

    /* Establece el valor del campo IdColor */
    public function setIdColor( $i_IdColor )
    {
        $this->i_IdColor = $i_IdColor;
    }

    /* Obtiene el valor del campo IdColor */
    public function getIdColor()
    {
        return $this->i_IdColor;
    }

    /* Establece el valor del campo IdCatTalla */
    public function setIdCatTalla( $i_IdCatTalla )
    {
        $this->i_IdCatTalla = $i_IdCatTalla;
    }

    /* Obtiene el valor del campo IdCatTalla */
    public function getIdCatTalla()
    {
        return $this->i_IdCatTalla;
    }

    /* Establece el valor del campo Aplicado */
    public function setAplicado( $i_Aplicado )
    {
        $this->i_Aplicado = $i_Aplicado;
    }

    /* Obtiene el valor del campo Aplicado */
    public function getAplicado()
    {
        return $this->i_Aplicado;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdReferencia' => $this->getIdReferencia(),
            'IdColor' => $this->getIdColor(),
            'IdCatTalla' => $this->getIdCatTalla(),
            'Aplicado' => $this->getAplicado(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto MST_ReferenciaProductoCatTallaBN desde un RecordSet */
    public static function retrieveByRs( $o_MST_ReferenciaProductoCatTallaRs )
    {
        $o_MST_ReferenciaProductoCatTallaBN = new MST_ReferenciaProductoCatTallaBN();
        $o_MST_ReferenciaProductoCatTallaBN->setIdReferencia( ( integer ) $o_MST_ReferenciaProductoCatTallaRs[ "IdReferencia" ] );
        $o_MST_ReferenciaProductoCatTallaBN->setIdColor( ( integer ) $o_MST_ReferenciaProductoCatTallaRs[ "IdColor" ] );
        $o_MST_ReferenciaProductoCatTallaBN->setIdCatTalla( ( integer ) $o_MST_ReferenciaProductoCatTallaRs[ "IdCatTalla" ] );
        $o_MST_ReferenciaProductoCatTallaBN->setAplicado( ( integer ) $o_MST_ReferenciaProductoCatTallaRs[ "Aplicado" ] );
        $o_MST_ReferenciaProductoCatTallaBN->setUsuarioCreacion( $o_MST_ReferenciaProductoCatTallaRs[ "UsuarioCreacion" ] );
        $o_MST_ReferenciaProductoCatTallaBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_MST_ReferenciaProductoCatTallaRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_MST_ReferenciaProductoCatTallaBN->setUsuarioModificacion( $o_MST_ReferenciaProductoCatTallaRs[ "UsuarioModificacion" ] );
        $o_MST_ReferenciaProductoCatTallaBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_MST_ReferenciaProductoCatTallaRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        return $o_MST_ReferenciaProductoCatTallaBN;
    }
}
?>